//
//  CredentialStore.h
//  asynctransport
//
//  Created by Angel Terziev on 7/11/12.
//  Copyright (c) 2012 FuzeBox, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface CredentialStore : NSObject
{
    NSCondition* _cndHttpProxy;
    BOOL         _fCondition;
    BOOL         _isCancelled;
    
    NSMutableDictionary* _store;
    NSMutableDictionary* _invalidStore;
}

+ (CredentialStore*) instance;

- (NSDictionary*) credentialsForProxy: ( NSString* ) proxyAddress;
- (NSDictionary*) credentialsForProxy: ( NSString* ) proxyAddress isCancelled: (BOOL*) isCancelled;
- (NSDictionary*) credentialsForProxyIfAny: ( NSString* ) proxyAddress;

- (void) invalidateCredentialsForProxy: ( NSString* ) proxyAddress;
- (void) validateCredentialsForProxy: ( NSString* ) proxyAddress; // also saves them in keychain if allowed by the user

@end


extern NSString* const kCredStoreItemTypeUsername;
extern NSString* const kCredStoreItemTypePassword;
extern NSString* const kCredStoreItemTypeRemember;
